import java.util.List;
import java.util.LinkedList;


public class OneDimSlidingDomain implements PlanningDomain {

	public OneDimSlidingState nextState(State state_in, int action) {
		OneDimSlidingState state = (OneDimSlidingState) state_in;

		int[] stateRep = state.getStateRep();
		int zeroIdx = state.getZeroIdx();
		int swapIdx = zeroIdx;
		if ((action == 0) && (zeroIdx < (stateRep.length - 1))) {
			//swap right 1
			swapIdx = zeroIdx + 1;
		} else if ((action == 1) && (zeroIdx < (stateRep.length - 2))) {
			//swap right 2
			swapIdx = zeroIdx + 2;
		} else if ((action == 2) && zeroIdx > 0) {
			//swap left 1
			swapIdx = zeroIdx - 1;
		} else if ((action == 3) && (zeroIdx > 1)) {
			//swap left 2
			swapIdx = zeroIdx - 2;
		}
		
		
		stateRep[zeroIdx] = stateRep[swapIdx];
		stateRep[swapIdx] = 0;
		zeroIdx = swapIdx;
		return new OneDimSlidingState(stateRep, zeroIdx);
	}

	@Override
	public float transitionCost(State state, int action, State nextState) {
		return 1;
	}

	@Override
	public boolean isSolved(State state_in) {
		OneDimSlidingState state = (OneDimSlidingState) state_in;
		int[] stateRep = state.getStateRep();
		int expectedNum = 0;
		for (int i=0; i<stateRep.length; i++) {
			if (expectedNum != stateRep[i]) {
				return false;
			}
			expectedNum++;
		}
		
		return true;
	}

	@Override
	public List<Integer> getStateActions(State state_in) {
		List<Integer> validActs = new LinkedList<Integer>();
		OneDimSlidingState state = (OneDimSlidingState) state_in;
		int[] stateRep = state.getStateRep();
		int zeroIdx = state.getZeroIdx();

		if (zeroIdx < (stateRep.length - 1)) {
			//swap right 1
			validActs.add(0);
		} 
		if (zeroIdx < (stateRep.length - 2)) {
			//swap right 2
			validActs.add(1);
		} 
		if (zeroIdx > 0) {
			//swap left 1
			validActs.add(2);
		} 
		if (zeroIdx > 1) {
			//swap left 2
			validActs.add(3);
		}

		return validActs;
	}
}
