
public class OneDimSlidingState implements State {
	private int[] stateRep;
	private int zeroIdx;
	
	public OneDimSlidingState(int[] stateRep) {
		this.stateRep = stateRep;
		boolean foundZero = false;
		int idx = 0;
		while (!foundZero) {
			if (this.stateRep[idx] == 0) {
				this.zeroIdx = idx;
				foundZero = true;
			}
			idx++;
		}
	}
	
	public OneDimSlidingState(int[] stateRep, int zeroIdx) {
		this.stateRep = stateRep;
		this.zeroIdx = zeroIdx;
	}
	
	public int[] getStateRep() {
		return this.stateRep.clone();
	}
	
	public int getZeroIdx() {
		return this.zeroIdx;
	}

	
	public boolean equals(State stateOther) {
		if (stateOther instanceof OneDimSlidingState) {
			return this.stateRep.equals(((OneDimSlidingState) stateOther).stateRep);
		} else {
			return false;
		}
	}
	
	public int hashCode() {
		int hash = 0;
		for (int i=0; i<this.stateRep.length; i++) {
			hash += Math.pow(10, this.stateRep.length - 1 - i) * (this.stateRep[i]);
		}
		
		return hash;
	}
	
	public String toString() {
		String stringRep = "";
		for (int i=0; i<this.stateRep.length; i++) {
			stringRep = stringRep + this.stateRep[i];
		}
		
		return stringRep;
	}
}
